#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <sqlx>

#define NAME "Death[r]un bank(mysql)"
#define VERSION "1.0"
#define AUTHOR "Crash94"

new Handle:SQL_Tuple
new Handle:SQL_Connection 

new logdate[64], logfile[64],  szText[ 555 char ], limited[33]
new account_password[33], account_money[33], account_reg[33], account_auth[33], 
account_invalid_pass[33], account_regdata[33], account_lastdata[33]

new g_Invalid

public plugin_init()
{
   register_plugin(NAME, VERSION, AUTHOR)

   register_cvar("amx_bankinfo_hostname","127.0.0.1")
   register_cvar("amx_bankinfo_username","root")
   register_cvar("amx_bankinfo_password","vertrigo")
   register_cvar("amx_bankinfo_database","bank")
   g_Invalid = register_cvar( "amx_bank_invalidpass", "3" )

   register_clcmd("say /bank", "MainMenu")
   register_clcmd("say_team /bank", "MainMenu")

   register_clcmd("borrow_money", "Borrow_His")
   register_clcmd("deduce_money", "Deduce_His")
   register_clcmd("bank_password", "bank_savepassword")
   register_clcmd("bank_assecpassword", "bank_assec") 

   set_task(1.0, "mysql_connection")
   register_dictionary( "deathrun_bank.txt" );
}

public plugin_precache()
{
   new logdir[64]
   get_configsdir(logdir, 63)
   get_time("20%y.%m.%d", logdate, 63)
   formatex(logfile, 63, "deathrun_bank_%s.log", logdate)
}

public mysql_connection(id)
{
   new hostname[33], username[33], password[33], database[33]
   new err, error[256]

   get_cvar_string("amx_bankinfo_hostname", hostname, 30)
   get_cvar_string("amx_bankinfo_username", username, 30)
   get_cvar_string("amx_bankinfo_password", password, 30)
   get_cvar_string("amx_bankinfo_database", database, 30)

   SQL_Tuple = SQL_MakeDbTuple(hostname, username, password, database)
   SQL_Connection = SQL_Connect(SQL_Tuple, err, error, charsmax(error))
     
   if(SQL_Connection != Empty_Handle)
   {
      formatex( szText, charsmax( szText ), "[CONNECT]%L", id, "CONNECT_OK");
      log_to_file(logfile, szText )
   }else{
      formatex( szText, charsmax( szText ), "[CONNECT]%L", id, "CONNECT_FAILED", error);
      log_to_file(logfile, szText )
      set_fail_state(error)
   }
}

public client_putinserver(id)
{
   check_players(id)
}

public client_disconnect(id)
{
   account_password[id] = 0
   account_money[id] = 0
   account_reg[id] = 0
   account_auth[id] = false
   account_invalid_pass[id] = 0
   client_cmd (id, "setinfo bank_pw 0")	
}

public check_players(id)
{
    new szName[32], szTemp[512]
    get_user_name(id, szName, charsmax(szName))
    
    new Data[1]
    Data[0] = id
    
    format(szTemp,charsmax(szTemp),"SELECT * FROM `banks_account` WHERE (`banks_account`.`nickname` = '%s')", szName)
    SQL_ThreadQuery(SQL_Tuple, "register_client",szTemp,Data,1)
}

public register_client(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
   if(FailState == TQUERY_CONNECT_FAILED)
   {
      formatex( szText, charsmax( szText ), "[CONNECT]%L", 0, "SELECT_CONNECT_FAILED", Errcode, Error);
      log_to_file(logfile, szText )
      set_fail_state(Error)
   }else 
   if(FailState == TQUERY_QUERY_FAILED)
   {
      formatex( szText, charsmax( szText ), "[CONNECT]%L", 0, "SELECT_QUERY_FAILED", Errcode, Error);
      log_to_file(logfile, szText )
      set_fail_state(Error)
   }

   new id
   id = Data[0]
    
   if(SQL_NumResults(Query) < 1) 
   { 
        new szTemp[512]

        account_reg[id] = 0
        SQL_ThreadQuery(SQL_Tuple, "IgnoreHandle", szTemp)
   } else {
        account_reg[id] = 1
        account_password[id] = SQL_ReadResult(Query, 2)
        account_money[id] = SQL_ReadResult(Query, 3)
        account_regdata[id] = SQL_ReadResult(Query, 4)
        account_lastdata[id] = SQL_ReadResult(Query, 5)
        client_cmd (id, "setinfo bank_pw %i", account_password[id])
   }
   return PLUGIN_HANDLED
}

public database_update(id)
{
   if(account_reg[id]==1 && account_auth[id])
   {
      new szName[32], szTemp[512]
      get_user_name(id, szName, charsmax(szName))

      format(szTemp,charsmax(szTemp),"UPDATE `banks_account` SET `bankmoney`= '%i' WHERE `banks_account`.`nickname` = '%s';",account_money[id], szName)
      SQL_ThreadQuery(SQL_Tuple,"IgnoreHandle",szTemp)
   }

}

public IgnoreHandle(FailState,Handle:Query,Error[],Errcode,Data[],DataSize)
{
   SQL_FreeHandle(Query)
   return PLUGIN_HANDLED
}

stock ChatColor(const id, const input[], any:...)
{
    new count = 1, players[32]
    static msg[191]
    vformat(msg, 190, input, 3)
    
    replace_all(msg, 190, "!g", "^4")
    replace_all(msg, 190, "!y", "^1")
    replace_all(msg, 190, "!team", "^3")
    
    if (id) players[0] = id; else get_players(players, count, "ch")
    {
        for (new i = 0; i < count; i++)
        {
            if (is_user_connected(players[i]))
            {
                message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i]);
                write_byte(players[i]);
                write_string(msg);
                message_end();
            }
        }
    }
} 

public MainMenu(id)
{
   if(account_auth[id])
   {
      new szText[ 555 char ], szMoney
      szMoney = cs_get_user_money(id)

      formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_MENU_TITLE", account_money[id]);
      new menu = menu_create( szText, "MainMenu_handler" );

      if(szMoney >= 1)
      {
         formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_ITEM_1" );
         menu_additem( menu, szText, "1", 0 );
      }else{
         formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_ITEM_1" );
         menu_additem( menu, szText, "1", ADMIN_ADMIN );
      }

      if(account_money[id] >= 1)
      {
         formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_ITEM_2" );
         menu_additem( menu, szText, "2", 0 );
      }else{
         formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_ITEM_2" );
         menu_additem( menu, szText, "2", ADMIN_ADMIN );
      }
      menu_setprop( menu, MPROP_EXIT, MEXIT_ALL );
      menu_setprop( menu, MPROP_EXITNAME, "Выход")
      menu_display( id, menu, 0 );
   }else
   if(account_reg[id]==0)
   {
      new szText[ 555 char ];

      formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_REG_TITLE");
      new menu = menu_create( szText, "MainMenu_Reg_handler" );

      formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_REG_ITEM_1" );
      menu_additem( menu, szText, "1", 0 );

      menu_setprop( menu, MPROP_EXIT, MEXIT_ALL );
      menu_setprop( menu, MPROP_EXITNAME, "Выход")
      menu_display( id, menu, 0 );
   }else{
      new szText[ 555 char ];

      formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_AUTH_TITLE");
      new menu = menu_create( szText, "MainMenu_Auth_handler" );

      formatex( szText, charsmax( szText ), "%L", id, "MAINBANK_AUTH_ITEM_1" );
      menu_additem( menu, szText, "1", 0 );

      menu_setprop( menu, MPROP_EXIT, MEXIT_ALL );
      menu_setprop( menu, MPROP_NEXTNAME, "Далее")
      menu_setprop( menu, MPROP_BACKNAME, "Назад")
      menu_setprop( menu, MPROP_EXITNAME, "Выход")
      menu_display( id, menu, 0 );
   }
}

public MainMenu_handler( id, menu, item )
{
     if( item == MENU_EXIT )
     {
          menu_destroy( menu );
          return PLUGIN_HANDLED;
     }

     new data[ 6 ], iName[ 64 ], access, callback;
     menu_item_getinfo( menu, item, access, data, charsmax( data ), iName, charsmax( iName ), callback );

     new key = str_to_num( data );
	
     switch( key )
     {
          case 1:
          {
             Borrow(id)
          }

          case 2:
          {
             Deduce(id)
          }
     }
     return PLUGIN_HANDLED;
}

public MainMenu_Reg_handler( id, menu, item )
{
     if( item == MENU_EXIT )
     {
          menu_destroy( menu );
          return PLUGIN_HANDLED;
     }

     new data[ 6 ], iName[ 64 ], access, callback;
     menu_item_getinfo( menu, item, access, data, charsmax( data ), iName, charsmax( iName ), callback );

     new key = str_to_num( data );
	
     switch( key )
     {
          case 1:
          {
             Registration(id)
          }
     }
     return PLUGIN_HANDLED;
}

public MainMenu_Auth_handler( id, menu, item )
{
     if( item == MENU_EXIT )
     {
          menu_destroy( menu );
          return PLUGIN_HANDLED;
     }

     new data[ 6 ], iName[ 64 ], access, callback;
     menu_item_getinfo( menu, item, access, data, charsmax( data ), iName, charsmax( iName ), callback );

     new key = str_to_num( data );
	
     switch( key )
     {
          case 1:
          {
             authorization(id)
             if(!account_invalid_pass[id])
             {
                account_invalid_pass[id] = get_pcvar_num(g_Invalid)
             }
          }
     }
     return PLUGIN_HANDLED;
}

public Borrow(id)
{
   new szText[ 555 char ], szMoney
   szMoney = cs_get_user_money(id)

   formatex( szText, charsmax( szText ), "%L", id, "BORROW_MENU_TITLE", szMoney);
   new menu = menu_create( szText, "Borrow_handler" );

   if(szMoney>=3000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_1" );
      menu_additem( menu, szText, "1", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_1" );
      menu_additem( menu, szText, "1", ADMIN_ADMIN );
   }

   if(szMoney>=5000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_2" );
      menu_additem( menu, szText, "2", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_2" );
      menu_additem( menu, szText, "2", ADMIN_ADMIN );
   }

   if(szMoney>=10000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_3" );
      menu_additem( menu, szText, "3", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_3" );
      menu_additem( menu, szText, "3", ADMIN_ADMIN );
   }

   if(szMoney>=15000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_4" );
      menu_additem( menu, szText, "4", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_4" );
      menu_additem( menu, szText, "4", ADMIN_ADMIN );
   }

   if(szMoney>=20000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_5" );
      menu_additem( menu, szText, "5", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_5" );
      menu_additem( menu, szText, "5", ADMIN_ADMIN );
   }

   formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_6" );
   menu_additem( menu, szText, "6", 0 );

   formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_7" );
   menu_additem( menu, szText, "7", 0 );

   menu_setprop( menu, MPROP_EXIT, MEXIT_ALL );
   menu_setprop( menu, MPROP_NEXTNAME, "Далее")
   menu_setprop( menu, MPROP_BACKNAME, "Назад")
   menu_setprop( menu, MPROP_EXITNAME, "Выход")
	
   menu_display( id, menu, 0 );
}

public Borrow_handler( id, menu, item )
{
     if( item == MENU_EXIT )
     {
          menu_destroy( menu );
          return PLUGIN_HANDLED;
     }

     new data[ 6 ], iName[ 64 ], access, callback;
     menu_item_getinfo( menu, item, access, data, charsmax( data ), iName, charsmax( iName ), callback );

     new key = str_to_num( data );
	
     switch( key )
     {
          case 1:
          {
             cs_set_user_money(id, cs_get_user_money(id)-3000)
             account_money[id]=account_money[id]+3000
             limited[id]=3000
             ChatColor(id, "!g[BANK]!y%L",0,"BORROW_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 2:
          {
             cs_set_user_money(id, cs_get_user_money(id)-5000)
             account_money[id]=account_money[id]+5000
             limited[id]=5000
             ChatColor(id, "!g[BANK]!y%L",0,"BORROW_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 3:
          {
             cs_set_user_money(id, cs_get_user_money(id)-10000)
             account_money[id]=account_money[id]+10000
             limited[id]=10000
             ChatColor(id, "!g[BANK]!y%L",0,"BORROW_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 4:
          {
             cs_set_user_money(id, cs_get_user_money(id)-15000)
             account_money[id]=account_money[id]+15000
             limited[id]=15000
             ChatColor(id, "!g[BANK]!y%L",0,"BORROW_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 5:
          {
             cs_set_user_money(id, cs_get_user_money(id)-20000)
             account_money[id]=account_money[id]+20000
             limited[id]=20000
             ChatColor(id, "!g[BANK]!y%L",0,"BORROW_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 6:
          {
             client_cmd(id, "messagemode ^"borrow_money %i^"", id) 
          }

          case 7:
          {
             account_money[id]=account_money[id]+cs_get_user_money(id)
             limited[id]=cs_get_user_money(id)
             cs_set_user_money(id, cs_get_user_money(id)-cs_get_user_money(id))
             ChatColor(id, "!g[BANK]!y%L",0,"BORROW_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }
     }
     return PLUGIN_HANDLED;
}

public Deduce(id)
{
   new szText[ 555 char ]

   formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_MENU_TITLE", account_money[id]);
   new menu = menu_create( szText, "Deduce_handler" );

   if(account_money[id]>=3000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_1" );
      menu_additem( menu, szText, "1", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_1" );
      menu_additem( menu, szText, "1", ADMIN_ADMIN );
   }

   if(account_money[id]>=5000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_2" );
      menu_additem( menu, szText, "2", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_2" );
      menu_additem( menu, szText, "2", ADMIN_ADMIN );
   }

   if(account_money[id]>=10000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_3" );
      menu_additem( menu, szText, "3", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_3" );
      menu_additem( menu, szText, "3", ADMIN_ADMIN );
   }

   if(account_money[id]>=15000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_4" );
      menu_additem( menu, szText, "4", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_4" );
      menu_additem( menu, szText, "4", ADMIN_ADMIN );
   }

   if(account_money[id]>=20000)
   {
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_5" );
      menu_additem( menu, szText, "5", 0 );
   }else{
      formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_5" );
      menu_additem( menu, szText, "5", ADMIN_ADMIN );
   }

   formatex( szText, charsmax( szText ), "%L", id, "DEDUCE_ITEM_6" );
   menu_additem( menu, szText, "6", 0 );

   formatex( szText, charsmax( szText ), "%L", id, "BORROW_ITEM_7" );
   menu_additem( menu, szText, "7", 0 );

   menu_setprop( menu, MPROP_EXIT, MEXIT_ALL );
   menu_setprop( menu, MPROP_EXITNAME, "Выход")
	
   menu_display( id, menu, 0 );
}

public Borrow_His(id)
{
   new param[10]
   read_argv(2, param, charsmax(param))
       
   for (new x; x < strlen(param); x++)
   {
      if(!isdigit(param[x]))
      {
          ChatColor(id, "!g[BANK]!y%L",0,"BORROW_NO_NUMBER")
          return PLUGIN_HANDLED
       }
   }
       
   new amount = str_to_num(param)
   new money = cs_get_user_money(id)
       
   if (money < amount)
   {
      ChatColor(id, "!g[BANK]!y%L",0,"BORROW_NO_MONEY")
      return PLUGIN_HANDLED
   }
       
   read_argv(1, param, charsmax(param))
   cs_set_user_money(id, cs_get_user_money(id)-amount)
   account_money[id]=account_money[id]+amount
       
   ChatColor(id, "!g[BANK]!y%L",0,"BORROW_BANKS", amount)
   database_update(id) 

   return PLUGIN_HANDLED
}

public Deduce_handler( id, menu, item )
{
     if( item == MENU_EXIT )
     {
          menu_destroy( menu );
          return PLUGIN_HANDLED;
     }

     new data[ 6 ], iName[ 64 ], access, callback;
     menu_item_getinfo( menu, item, access, data, charsmax( data ), iName, charsmax( iName ), callback );

     new key = str_to_num( data );
	
     switch( key )
     {
          case 1:
          {
             cs_set_user_money(id, cs_get_user_money(id)+3000)
             account_money[id]=account_money[id]-3000
             limited[id]=3000
             ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 2:
          {
             cs_set_user_money(id, cs_get_user_money(id)+5000)
             account_money[id]=account_money[id]-5000
             limited[id]=5000
             ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 3:
          {
             cs_set_user_money(id, cs_get_user_money(id)+10000)
             account_money[id]=account_money[id]-10000
             limited[id]=10000
             ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 4:
          {
             cs_set_user_money(id, cs_get_user_money(id)+15000)
             account_money[id]=account_money[id]-15000
             limited[id]=15000
             ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 5:
          {
             cs_set_user_money(id, cs_get_user_money(id)+20000)
             account_money[id]=account_money[id]-20000
             limited[id]=20000
             ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }

          case 6:
          {
             client_cmd(id, "messagemode ^"deduce_money %i^"", id) 
          }

          case 7:
          {
             limited[id]=account_money[id]
             cs_set_user_money(id, cs_get_user_money(id)+account_money[id])
             account_money[id]=0
             ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_BANKS", limited[id])
             limited[id] = 0
             database_update(id)
          }
     }
     return PLUGIN_HANDLED;
}

public Deduce_His(id)
{
   new param[10]
   read_argv(2, param, charsmax(param))
       
   for (new x; x < strlen(param); x++)
   {
      if(!isdigit(param[x]))
      {
          ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_NO_NUMBER")
          return PLUGIN_HANDLED
       }
   }
       
   new amount = str_to_num(param)
       
   if (account_money[id] < amount)
   {
      ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_NO_MONEY")
      return PLUGIN_HANDLED
   }
       
   read_argv(1, param, charsmax(param))
   cs_set_user_money(id, cs_get_user_money(id)+amount)
   account_money[id]=account_money[id]-amount
       
   ChatColor(id, "!g[BANK]!y%L",0,"DEDUCE_BANKS", amount)
   database_update(id)

   return PLUGIN_HANDLED
}

public Registration(id)
{
   client_cmd(id, "messagemode bank_password") 
   ChatColor(id, "!g[BANK]!y%L",0,"BANK_REG_INFO")
   ChatColor(id, "!g[BANK]!y%L",0,"BANK_REG_INFO2")
}

public bank_savepassword(id)
{
   new szName[32], szTemp[512], szArgs[512], szRegData[32], szLastData[32]

   read_args(szArgs, 511)
   remove_quotes(szArgs);
   get_user_name(id, szName, 31);
   get_time("%m.%d.%Y - [%H:%M]",szRegData,31)
   get_time("%m.%d.%Y - [%H:%M]",szLastData,31)

   for (new x; x < strlen(szArgs); x++)
   {
      if(!isdigit(szArgs[x]))
      {
          ChatColor(id, "!g[BANK]!y%L",0,"BANK_REG_NO_NUMBER")
          return PLUGIN_HANDLED
       }
   }

   format(szTemp,charsmax(szTemp),"INSERT INTO `banks_account` ( `nickname` , `password`, `bankmoney`, `registration_data`, `last_data`)VALUES ('%s','%s', '0', '%s', '%s');", szName, szArgs, szRegData, szLastData)
   SQL_ThreadQuery(SQL_Tuple,"IgnoreHandle",szTemp)

   client_cmd (id, "setinfo bank_pw %s", szArgs)
   account_reg[id]=1
   ChatColor(id, "!g[BANK]!y%L",0,"BANK_REG_PASSWORD", szArgs) 
   return PLUGIN_HANDLED
}

public authorization(id)
{
   client_cmd(id, "messagemode bank_assecpassword") 
}

public bank_assec(id)
{
   new szArgs[512], password[33]

   read_args(szArgs, 511)
   remove_quotes(szArgs);

   get_user_info (id, "bank_pw", password, 33)

   if (equal(password, szArgs))
   {
      account_auth[id] = true
      ChatColor(id, "!g[BANK]!y%L",0,"BANK_AUTH_INFO")

      new szName[32], szTemp[512], szLastData[32]
      get_user_name(id, szName, charsmax(szName))
      get_time("%m.%d.%Y - [%H:%M]",szLastData,31)

      format(szTemp,charsmax(szTemp),"UPDATE `banks_account` SET `last_data`= '%s' WHERE `banks_account`.`nickname` = '%s';",szLastData, szName)
      SQL_ThreadQuery(SQL_Tuple,"IgnoreHandle",szTemp)
    }else{
       --account_invalid_pass[id]
       ChatColor(id, "!g[BANK]!y%L",0,"BANK_AUTH_INVALIDPASS", account_invalid_pass[id])
       if(account_invalid_pass[id]==0)
       {
          server_cmd("kick #%d ^"%L^"", get_user_userid(id), id, "INVALID_PASSWORD")
          return PLUGIN_HANDLED
       }
   }
   return PLUGIN_HANDLED
}

public client_infochanged(id)
{
	if (is_user_connected(id))
	{
		new s_NewName[32], s_OldName[32]
		
		get_user_info(id, "name", s_NewName, charsmax(s_NewName))
		get_user_name(id, s_OldName, charsmax(s_OldName))
		
		if (!equali(s_OldName, s_NewName))
			set_user_info(id, "name", s_OldName)
	}
}